Bug 999224 - [upgrade] correctly detect if packages can be rollbacked
[upgrade] correctly detect if packages can be rollbacked
Status: CLOSED ERRATA
Product: Red Hat Enterprise Virtualization Manager
Classification: Red Hat
Component: ovirt-engine-setup (Show other bugs)
3.2.0
Unspecified Unspecified
high Severity high
: ---
: 3.2.3
Assigned To: Yedidyah Bar David
Ilanit Stein
integration
: ZStream
Depends On: 998921
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-20 19:24 EDT by Chris Pelland
Modified: 2013-09-10 15:08 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Before beginning an upgrade, engine-upgrade now correctly checks if packages can be rolled back to an already-installed version, and warns users when rollback is not possible if the upgrade fails.
Story Points: ---
Clone Of: 998921
Environment:
Last Closed: 2013-09-10 15:08:11 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
oVirt gerrit 18310 None None None Never
oVirt gerrit 18311 None None None Never

  None (edit)
Comment 3 Ilanit Stein 2013-08-25 08:56:21 EDT
Verified on sf20:

flow:
1. Have two repos for 3.2.2(sf19.1) and 3.2.3(sf20)
2. Disable repo of 3.2.2 and try to upgrade sorry
3. Upgrade failed on no rollback available:
Error: Installed packages are missing from the yum repositories
Please check your yum repositories or use --no-yum-rollback
Error: Upgrade failed.
4. Enable repo of 3.2.2
5. Try to upgrade: upgrade successful, No prompt on "no rollback is available"
Comment 4 Yedidyah Bar David 2013-09-02 02:08:54 EDT
Hi Cheryn and all,

I would not like to continue the "Change Doc text game", so I'll explain in longer words what this change does, and let you decide about the phrasing for the Doc Text.

When running engine-upgrade, the script checks if there are new updated RPMs. If there are, it also checks if the existing, already-installed, packages, can still be installed from the configured yum repos. If they are not, it alerts the user, and refuses to continue, unless ran with the option '--no-yum-rollback'. All of this is done on startup, in preparation for a potential failure, and not on the failure itself - if there is a failure after updating to the new RPMs, it simply tries to downgrade.

This change fixes the above check. Without it, on certain conditions, it was possible that while checking the script would think that it will be able to downgrade to the currently-installed RPMs, while in practice it could not, and if there was a failure and it would try to downgrade, the downgrade will fail.

The current Doc Text is completely accurate if we put the parenthesis in a less natural position:

"engine-upgrade now warns users when (packages cannot be rolled back to a currently installed version if an upgrade fails)."

The natural position is:
"(engine-upgrade now warns users when packages cannot be rolled back to a currently installed version) if an upgrade fails."
and is wrong.

I am not a native English speaker and so might be wrong.

Best regards!
Comment 5 Cheryn Tan 2013-09-02 03:29:12 EDT
Thank you for your detailed corrections, Yedidyah and Alon. Spoke with Didi on IRC earlier and I think the new note now accurately describes the bug.
Comment 7 errata-xmlrpc 2013-09-10 15:08:11 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-1210.html

Note You need to log in before you can comment on or make changes to this bug.